<template src="./template.html"></template>

<script lang="ts">
import { getModule } from "nuxt-property-decorator";
import { Vue, Component, Prop, Watch } from "vue-property-decorator";
import { apiErrorHandler } from "~/utils/apiHanlers";
import CountryFlag from "vue-country-flag";
//@ts-ignore
import listCountry from "~/locales/listCountry.json";
import { IShippingListPrice, IShipping, ICountry } from "~/interfaces/shipping";

@Component({
  layout: "admin",
  middleware: "authenticated",
  components: {
    CountryFlag,
  },
})
export default class EditShippingZoneComponent extends Vue {
  loading = false;
  zoneName = "VietNam";
  loadingTable = false;
  shippingId = "";
  shippingDetail = {} as IShipping;
  dialogAddCountry = false;
  dialogAddItemQuantity = false;
  listCountrySort = [];
  listCountry = listCountry;
  shippingName = "";
  shippingCost = 0;
  quantityItems = 0;
  isMax = 0;
  isExistingQuantity = false;
  nameSortCountry = "";
  dialogAddItemQuantityItem = false;
  priceItem = [];
  listShipping = [];

  deleteCountry(idx: number) {
    this.shippingDetail.listCountry.splice(idx, 1);
  }
  async mounted() {
    this.shippingId = this.$route.params.id;
    this.getListShipping();
    this.getDetailShipping();
    this.listCountrySort = this.listCountry;
  }

  async getListShipping() {
    try {
      const response = await this.$api.shipping.allShippingAdmin();
      if (response?.data) {
        this.listShipping = response.data.data;
        const listShippingOther = this.listShipping.filter(
          (shipping: IShipping) =>
            //@ts-ignore
            shipping._id !== this.shippingDetail._id && !shipping.isRestOfWorld
        );
        const listCountryOther: string[] = [];
        listShippingOther.forEach((quocgia: IShipping) => {
          for (let item of quocgia.listCountry) {
            listCountryOther.push(item);
          }
        });
        this.listCountrySort = this.listCountrySort.filter(
          (quocgia: ICountry) => {
            return !listCountryOther.includes(quocgia.code);
          }
        );
      }
    } catch (error) {
      apiErrorHandler(error, this);
    }
  }

  async onDeleteShipping() {
    try {
      await this.$api.shipping.delete(this.shippingId);
      this.$pushNotification.success("Delete successfully");
      this.$router.push("/admin/shipping");
    } catch (error) {}
  }

  async onEditShippingZone() {
    try {
      const checkQuantityInclude1 = this.shippingDetail.listPrice
        .map((item: any) => {
          return Number(item.quantity);
        })
        .includes(1);
      if (checkQuantityInclude1) {
        const payload = {
          name: this.shippingDetail.name,
          desc: this.shippingDetail.desc,
          listPrice: this.shippingDetail.listPrice,
          listCountry: this.shippingDetail.listCountry,
        };
        this.loading = true;
        await this.$api.shipping.edit(this.shippingId, payload);
        this.$pushNotification.success("Edit Successfully");
        this.$router.push("/admin/shipping");
      } else {
        return this.$pushNotification.error("Must be include 1 quantity");
      }
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loading = false;
    }
  }

  deleteItem(idx: number) {
    this.shippingDetail.listPrice.splice(idx, 1);
  }

  addItemQuantityRate() {
    try {
      if (!this.shippingName) {
        return this.$pushNotification.error("Please fill rate name");
      }
      if (!this.shippingCost) {
        return this.$pushNotification.error("Please fill shipping cost");
      } else {
        this.loadingTable = true;
        this.shippingDetail.listPrice.push({
          name: this.shippingName,
          price: this.shippingCost,
          quantity: this.quantityItems,
        });
        this.shippingDetail.listPrice.sort((a, b) => {
          return a.quantity - b.quantity;
        });

        this.dialogAddItemQuantity = false;
        this.shippingName = "";
        this.shippingCost = 0;
        this.quantityItems = 0;
        this.isMax = 0;
      }
    } catch (error) {
      console.log("error :>> ", error);
    } finally {
      this.loadingTable = false;
    }
  }

  async getDetailShipping() {
    try {
      const response = await this.$api.shipping.shippingDetail(this.shippingId);
      if (response?.data) {
        this.shippingDetail = response.data;
      }
    } catch (error) {
      apiErrorHandler(error, this);
    }
  }

  @Watch("nameSortCountry")
  sortCountryInput(value: string) {
    if (value) {
      this.listCountrySort = this.listCountry.filter((item: any) =>
        item.name.toLowerCase().includes(value.toLowerCase())
      );
    }
  }

  shippingEdit = {};

  openDialogQuantityItem(id: string) {
    this.dialogAddItemQuantityItem = true;
    const findShipping = this.shippingDetail.listPrice.find(
      (item: IShippingListPrice) => {
        return item._id === id;
      }
    );
    if (findShipping) {
      this.shippingEdit = findShipping;
    }
  }

  findCountryName(quocgia: string) {
    const findCountry: ICountry = this.listCountry.find(
      (country: any) => country.code === quocgia
    ) || { name: "", code: "" };

    return findCountry.name || "";
  }

  @Watch("quantityItems")
  checkQuantity(value: number) {
    const isExisting = this.shippingDetail.listPrice.findIndex(
      (item: IShippingListPrice) => {
        return item.quantity == value;
      }
    );
    if (isExisting > -1) {
      this.isExistingQuantity = true;
    } else {
      this.isExistingQuantity = false;
    }
    if (this.shippingDetail.listPrice && this.shippingDetail.listPrice.length) {
      if (
        Number(value) <
        Number(
          this.shippingDetail.listPrice[
            this.shippingDetail.listPrice.length - 1
          ].quantity
        )
      ) {
        const findMax = this.shippingDetail.listPrice.find(
          (item: IShippingListPrice) => {
            return Number(item.quantity) > Number(value);
          }
        );
        if (findMax) {
          this.isMax = Number(findMax.quantity) - 1;
        } else {
          this.isMax = 0;
        }
      } else {
        this.isMax = 0;
      }
    }
  }
}
</script>

<style lang="scss" scoped>
th,
td {
  border: 1px solid #f1f5f9;
}
</style>
